Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0008320opensim[GRID] Inventory Servicepublic2018-04-19 20:442018-04-23 08:23
Reportermewtwo0641 
Assigned To 
PrioritynormalSeverityminorReproducibilityrandom
StatusnewResolutionopen 
PlatformOSOS Version
Product Versionmaster (dev code) 
Target VersionFixed in Version 
Summary0008320: XINVENTORY - Underlying connection was closed
DescriptionOpenSim httptests branch

I'm getting random errors/warnings on inventory load that the underlying connection was closed and it throws an exception. Some times this results in a rather short message but other times it seems to output a lot of XML into the console which appears to be the item data at the point where the exception was thrown.

This may not show up on small inventories but appears to show up randomly on larger inventories at some point during its load.

I've not yet came across the XML output log again but I will post it here if it happens.

I understand this branch is considered highly experimental, but I wanted to note this issue that I came across in my testings/experimenting with it.
Steps To ReproduceLog into OpenSim on a blank viewer cache (with inventory cache removed).
Additional InformationError/Exception Log:

22:27:21 - [FORMS]: Error receiving response from http://192.168.1.122:8003/xinv [^]
entory: The underlying connection was closed: A connection that was expected to
be kept alive was closed by the server.. Request: METHOD=GETMULTIPLEFOLDERSCONTE
NT&PRINCIPAL=48ec4192-1f87-40b1-b445-0dbf35b9fc62&FOLDERS=ea7eebca-a2c4-434d-b4a
7-64913a25bc72%2c41068665-6e6d-4b2d-ba79-aeee05478c88%2c66c0681d-2237-4f8e-9504-
cb5ef05dfa

22:27:21 - [XINVENTORY SERVICES CONNECTOR]: Exception in GetMultipleFoldersConte
nt: The underlying connection was closed: A connection that was expected to be k
ept alive was closed by the server.
TagsNo tags attached.
Git Revision or version number
Run Mode Grid (Multiple Regions per Sim)
Physics EngineubODE
Environment.NET / Windows64
Mono VersionNone
Viewer
Attached Files

- Relationships

-  Notes
(0032651)
watcher64 (reporter)
2018-04-19 21:16

Happens when the connection is dropped or interrupted for some reason, before the request is completed. Not been able to track it down but I can make it happen ..
(0032652)
tampa (reporter)
2018-04-19 22:21

Inventory is very bad, when inventory is large it takes long to load and can fail easily. Often running into database, IO and connection timeouts. Can be solved by throwing hardware at the problem, check disk and network usage.
(0032653)
UbitUmarov (administrator)
2018-04-20 00:15

master code has defective keep alive suport.
httptests branch should have it improved.
but default agreement about time to keep alive may need more care
The industry standard default is a bit 2 high for our uses.
note that for this both ends must be complaient, so httptests on a master grid will still show issues like this.
(0032654)
UbitUmarov (administrator)
2018-04-20 00:17

btw underline .net or mono framework should handle this gracefull and did it in past, guess things are changing and as usual not necessary for the best
(0032655)
mewtwo0641 (reporter)
2018-04-20 00:43

As a point of reference for this issue, I am testing httptests branch on .NET 4.6.1... I probably should update that and see if the issue persists. But in the short term I suppose my question would be; Would seeing these exceptions pop up cause any inventory issues, whether temporary, or permanent?
(0032656)
watcher64 (reporter)
2018-04-20 00:55

Don't think it should really cause any issues, the connection is closed what you see on the screen is what it is trying to send. I'm sure if the viewer requests it again it will get sent again. It should do it quietly as Ubit said, but it is now for some reason overly spammy ...
(0032657)
UbitUmarov (administrator)
2018-04-20 01:24

ok found a possible issue on http server keep alive response header and changed
(0032658)
mewtwo0641 (reporter)
2018-04-20 02:47

@watcher64 - Ah okay I was wondering because I wasn't sure if the viewer would request the item again or just give up on it.

@Ubit - Thank you, I'll update my test server with the change and keep an eye out for it :)
(0032662)
mewtwo0641 (reporter)
2018-04-23 00:21

I haven't seen the inventory timeouts yet in the past few days of testing but I am thinking the timeout issues might be affecting more than just inventory; I have been noticing that it also affects region crossings/teleports as well and it can be difficult to get an agent into a different region (From within the same simulator in my experience) without having to relog and try again, relog directly into the target region, or in extreme case having to restart the sim. May be possible on main branch too but I haven't noticed it as much as I do on httptests branch. I'm not sure if this needs to be put in a different mantis or maybe this mantis needs a subject revision?


Log:

02:10:48 - [SCENE]: Incoming child agent update for e47f7cb9-c067-4bce-b31f-ecb514caf4c4 in Test Region 1

02:11:18 - [SCENE PRESENCE]: Did not find presence with id e47f7cb9-c067-4bce-b31f-ecb514caf4c4 in Test Region 1 before timeout

02:11:18 - [ENTITY TRANSFER MODULE]: UpdateAgent failed on teleport of Test User to Test Region 1. Keeping avatar in Test Region 2

02:11:18 - [SCENE]: Called CloseClient() with agent ID e47f7cb9-c067-4bce-b31f-ecb514caf4c4 but no such presence is in Test Region 1
(0032663)
UbitUmarov (administrator)
2018-04-23 08:23

very diferent timeouts.

- Issue History
Date Modified Username Field Change
2018-04-19 20:44 mewtwo0641 New Issue
2018-04-19 21:16 watcher64 Note Added: 0032651
2018-04-19 22:21 tampa Note Added: 0032652
2018-04-20 00:15 UbitUmarov Note Added: 0032653
2018-04-20 00:17 UbitUmarov Note Added: 0032654
2018-04-20 00:43 mewtwo0641 Note Added: 0032655
2018-04-20 00:55 watcher64 Note Added: 0032656
2018-04-20 01:24 UbitUmarov Note Added: 0032657
2018-04-20 02:47 mewtwo0641 Note Added: 0032658
2018-04-20 21:12 mewtwo0641 Note Added: 0032661
2018-04-20 21:21 mewtwo0641 Note Deleted: 0032661
2018-04-23 00:21 mewtwo0641 Note Added: 0032662
2018-04-23 08:23 UbitUmarov Note Added: 0032663


Copyright © 2000 - 2012 MantisBT Group
Powered by Mantis Bugtracker